@import 'mixins/mixins';
@import 'common/var';

@mixin genTheme(
  $backgroundColorWeight,
  $borderColorWeight,
  $fontColorWeight,
  $hoverColorWeight
) {
  background-color: mix(
    $--tag-primary-color,
    $--color-white,
    $backgroundColorWeight
  );
  border-color: mix($--tag-primary-color, $--color-white, $borderColorWeight);
  color: mix($--tag-primary-color, $--color-white, $fontColorWeight);

  @include when(hit) {
    border-color: $--tag-primary-color;
  }

  .el-tag__close {
    color: mix($--tag-primary-color, $--color-white, $fontColorWeight);
  }

  &.el-tag--info {
    background: rgba(#7683ad, 0.2);
    color: #9BADD6;

    @include when(hit) {
      border-color: $--tag-info-color;
    }

    .el-tag__close {
      &::before,
      &::after {
        background-color: #0065ff;
      }
    }
  }

  &.el-tag--success {
    background-color: rgba(#00ffb3, 0.2);
    color: #00ffb3;

    @include when(hit) {
      border-color: $--tag-success-color;
    }

    .el-tag__close {
      &::before,
      &::after {
        background-color: #00ffb3;
      }
    }
  }

  &.el-tag--warning {
    background-color: mix(
      $--tag-warning-color,
      $--color-white,
      $backgroundColorWeight
    );
    border-color: mix($--tag-warning-color, $--color-white, $borderColorWeight);
    color: mix($--tag-warning-color, $--color-white, $fontColorWeight);

    @include when(hit) {
      border-color: $--tag-warning-color;
    }

    .el-tag__close {
      color: mix($--tag-warning-color, $--color-white, $fontColorWeight);
    }
  }

  &.el-tag--danger {
    background-color: mix(
      $--tag-danger-color,
      $--color-white,
      $backgroundColorWeight
    );
    border-color: mix($--tag-danger-color, $--color-white, $borderColorWeight);
    color: mix($--tag-danger-color, $--color-white, $fontColorWeight);

    @include when(hit) {
      border-color: $--tag-danger-color;
    }

    .el-tag__close {
      color: mix($--tag-danger-color, $--color-white, $fontColorWeight);
    }
  }
}

@include b(tag) {
  @include genTheme(10%, 20%, 100%, 100%);
  display: inline-flex;
  align-items: center;
  height: 34px;
  padding: $--tag-padding;
  color: $--tag-primary-color;
  font-size: $--tag-font-size;
  font-weight: bold;
  line-height: $--tag-font-size;
  letter-spacing: 0.8px;
  text-transform: uppercase;
  border-radius: $--tag-border-radius;
  box-sizing: border-box;
  white-space: nowrap;
  span {
    order: 2;
  }

  .el-icon-close {
    order: 1;
    position: relative;
    cursor: pointer;
    font-size: 0;
    height: 13px;
    width: 13px;
    display: flex;
    align-items: center;
    margin-right: 7px;
    &::before,
    &::after {
      position: absolute;
      flex: none;
      display: block;
      content: '';
      width: 13px;
      height: 2px;
      background-color: $--tag-close-color;
    }

    &::before {
      transform: rotate(45deg);
    }

    &::after {
      transform: rotate(-45deg);
    }
  }

  &[border] {
    border: 1px solid #373e57;
    background: 0;
  }

  @include m(dark) {
    @include genTheme(100%, 100%, 0, 80%);
  }

  @include m(plain) {
    @include genTheme(0, 40%, 100%, 100%);
  }

  @include m(medium) {
    height: 28px;
    line-height: 26px;

    .el-icon-close {
      transform: scale(0.8);
    }
  }

  @include m(small) {
    padding: 8px 15px;
    font-size: 14px;
    line-height: 18px;
    .el-icon-close {
      transform: scale(0.8);
    }
  }

  @include m(mini) {
    height: 20px;
    padding: 0 5px;
    line-height: 19px;

    .el-icon-close {
      margin-left: -3px;
      transform: scale(0.7);
    }
  }
}
